//
//  CountryInfoTableViewCell.swift
//  CountryDigest
//
//  Created by bhart on 10/13/22.
//

import UIKit

class CountryInfoTableViewCell: UITableViewCell {
    @IBOutlet weak var nameLabel: UILabel!
    @IBOutlet weak var regionLabel: UILabel!
    @IBOutlet weak var codeLabel: UILabel!
    @IBOutlet weak var capitalLabel: UILabel!
    
    //https://stackoverflow.com/questions/19212476/uitableview-separator-line-disappears-when-selecting-cells-in-ios7
    override func layoutSubviews() {
        super.layoutSubviews()

        subviews.forEach { (view) in
            if type(of: view).description() == "_UITableViewCellSeparatorView" {
                view.alpha = 1.0
            }
        }
    }
    
    func setup(with countryInfo: CountryInfoElement, andImage image: UIImage? = nil) {
        nameLabel.text = countryInfo.name + ","
        regionLabel.text = countryInfo.region.rawValue
        codeLabel.text = countryInfo.code
        capitalLabel.text = countryInfo.capital
    }
}
