//
//  CapitalSearchDataSource.swift
//  CountryDigest
//
//  Created by bhart on 10/13/22.
//

import Foundation
import UIKit

class GenericDataSource<T> : NSObject {
    var data: DynamicValue<[T]> = DynamicValue([])
}

class CapitalSearchDataSource : GenericDataSource<CountryInfoElement>, UITableViewDataSource {
    var filteredCountryInfo = [CountryInfoElement]()
    
    func numberOfSections(in tableView: UITableView) -> Int {
        return 1
    }
    
    func tableView(_ tableView: UITableView, numberOfRowsInSection section: Int) -> Int {
        if filteredCountryInfo.isEmpty {
            return data.value.count
        }
        return filteredCountryInfo.count
    }
    
    func tableView(_ tableView: UITableView, cellForRowAt indexPath: IndexPath) -> UITableViewCell {
        if let cell = tableView.dequeueReusableCell(withIdentifier: CountryInfoTableViewCell.reuseIdentifier , for: indexPath) as? CountryInfoTableViewCell {
            let countryInfo:CountryInfoElement
            if filteredCountryInfo.isEmpty {
                countryInfo = self.data.value[indexPath.row]
                
            } else {
                countryInfo = self.filteredCountryInfo[indexPath.row]
            }
            
            cell.setup(with: countryInfo)
            
            return cell
        } else {
            let cell = UITableViewCell()
            cell.textLabel?.text = self.data.value[indexPath.row].capital
            return cell
        }
    }
}
